import React from 'react';
import { Subscription } from './subscription';
export declare type ContextProvider<T> = {
    children: React.ReactNode;
    value?: T;
};
export declare type ContextSource = {
    [displayName: string]: any;
};
export declare type BaseContext<T extends ContextSource> = {
    [P in keyof T]: {
        state: React.Context<any>;
        dispatch: React.Context<any>;
        subscription: Subscription;
    };
};
export declare const createBaseContext: <T extends ContextSource>(contextSource: T) => BaseContext<T>;
