import React from 'react';
import { UseReducerContextSource, CurrentState } from './createUseReducerContexts';
import { ContextProvider } from '../core/createContext';
export declare type AnyReducer<S = any, A = any> = React.Reducer<S, A> | React.ReducerWithoutAction<S>;
export declare type ReducerState<R> = R extends React.ReducerWithoutAction<any> ? React.ReducerStateWithoutAction<R> : R extends React.Reducer<any, any> ? React.ReducerState<R> : never;
export declare type ReducerDispatch<R> = R extends React.ReducerWithoutAction<any> ? React.DispatchWithoutAction : R extends React.Reducer<any, any> ? React.Dispatch<React.ReducerAction<R>> : never;
export declare type UseReducerContext<T extends UseReducerContextSource> = {
    [P in keyof T]: {
        state: ReducerState<T[P]['reducer']>;
        dispatch: ReducerDispatch<T[P]['reducer']>;
    };
};
export declare const createUseReducerContext: <T extends UseReducerContextSource>(contextSource: T) => {
    store: import("./store").UseReducerStore<T>;
    contextProvider: React.FC<ContextProvider<CurrentState<T>>>;
    getState: () => CurrentState<T>;
};
