import React from 'react';
import { AnyReducer } from './createContext';
import { UseReducerStore } from './store';
import { ContextProvider } from '../core/createContext';
export declare type UseReducerContextSource = {
    [displayName: string]: {
        reducer: AnyReducer;
        initialState: any;
        initializer?: undefined;
    };
};
export declare type CurrentState<T extends UseReducerContextSource> = {
    [P in keyof T]: T[P]['initialState'];
};
/**
 * *useReducer* to create multiple contexts.
 * The created contexts are split into a state and a dispatch,
 * respectively, to prevent unnecessary rendering.
 */
export declare const createUseReducerContexts: <T extends UseReducerContextSource>(contextSource: T) => [UseReducerStore<T>, React.FC<ContextProvider<CurrentState<T>>>, () => CurrentState<T>];
