import { UseReducerContextSource, CurrentState } from './createUseReducerContexts';
import { ReducerState, ReducerDispatch } from './createContext';
import { BaseContext } from '../core/createContext';
declare type Store<State, Dispatch> = {
    state: {
        (): State;
        <SelectedState>(selector: (state: State) => SelectedState): SelectedState;
    };
    dispatch: () => Dispatch;
};
export declare type UseReducerStore<T extends UseReducerContextSource> = {
    [P in keyof T]: Store<ReducerState<T[P]['reducer']>, ReducerDispatch<T[P]['reducer']>>;
};
export declare const createStore: <T extends UseReducerContextSource>(baseContext: BaseContext<T>, getCurrentState: () => CurrentState<T>) => UseReducerStore<T>;
export {};
