import React from 'react';
import { UseStateContextSource } from './createUseStateContexts';
import { ContextProvider } from '../core/createContext';
export declare type UseStateContext<T extends UseStateContextSource> = {
    [P in keyof T]: {
        state: React.Context<T[P]>;
        dispatch: React.Context<React.Dispatch<React.SetStateAction<T[P]>>>;
    };
};
export declare const createUseStateContext: <T extends UseStateContextSource>(contextSource: T) => {
    context: import("../core/createContext").BaseContext<UseStateContext<T>>;
    store: import("./store").UseStateStore<T>;
    contextProvider: React.FC<ContextProvider<T>>;
    getState: () => T;
};
