import React from 'react';
import { UseStateStore } from './store';
import { ContextProvider } from '../core/createContext';
export declare type UseStateContextSource = {
    [displayName: string]: any;
};
/**
 * *useState* to create multiple contexts.
 * The created contexts are split into a state and a dispatch,
 * respectively, to prevent unnecessary rendering.
 */
export declare const createUseStateContexts: <T extends UseStateContextSource>(contextSource: T) => [UseStateStore<T>, React.FC<ContextProvider<T>>, () => T];
