import React from 'react';
import { UseStateContextSource } from './createUseStateContexts';
import { UseStateContext } from './createContext';
import { BaseContext } from '../core/createContext';
export declare type Store<State, Dispatch> = {
    state: {
        (): State;
        <SelectedState>(selector: (state: State) => SelectedState): SelectedState;
    };
    dispatch: () => Dispatch;
};
export declare type UseStateStore<T extends UseStateContextSource> = {
    [P in keyof T]: Store<T[P], React.Dispatch<React.SetStateAction<T[P]>>>;
};
export declare const createStore: <T extends UseStateContextSource>(baseContext: BaseContext<UseStateContext<T>>, getCurrentState: () => T) => UseStateStore<T>;
